<?php
namespace InternetGalerie\Igshop2\Controller;

use Internetgalerie\IgBackendHelpers\Controller\AbstractBackendTableListController;
use InternetGalerie\Igshop2\Domain\Repository\PropertyRepository;
use Psr\Http\Message\ResponseInterface;

class BackendPropertyController extends AbstractBackendTableListController
{
    protected string $tableName = 'tx_igshop2_domain_model_property';
    protected string $entryIdSearchAttribute = 'category'; // default is 'parent'
    protected PropertyRepository $propertyRepository;
 
    public function injectPropertyRepository(PropertyRepository $propertyRepository): void
    {
        $this->propertyRepository = $propertyRepository;
    }

    public function indexAction(): ResponseInterface
    {
        $selectedCategory = null;
        if ($this->entryId > 0) {
            //die('S='. $search['entryId']);
            $selectedCategory = $this->propertyRepository->findByUidBackend($this->entryId);
        }
        /*
        if ($selectedCategory) {
            $defVals = [
                $this->tableName => [
                    'category' =>  $selectedCategory->getUid()
                ],
            ];
        } else {
            $defVals = [];
        }
        */
        $this->view->assignMultiple([
            //            'defVals' => $defVals,
            'selectedCategory' => $selectedCategory,
        ]);

        //var_dump($defVals, $this->entryId);exit(0);
        //var_dump($defVals, $this->search);
        return parent::indexAction();
    }
}
