<?php
namespace InternetGalerie\Igshop2\Domain\Model;

use InternetGalerie\Igshop2\Domain\Repository\OptionWithPriceRepository;
use TYPO3\CMS\Core\Context\Context;
use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Persistence\ObjectStorage;

/**
 * Product
 */
class Product extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * productid
	 *
	 * @var string
	 */
	protected $productid = '';

	/**
	 * name
	 *
	 * @var string
	 */
	protected $name = '';

    /**
     * name
     *
     * @var string
     */
    protected $gtin = '';

    /**
     * gtin
     *
     * @var string
     */
    protected $mpn = '';

    /**
     * pharmacode
     *
     * @var string
     */
    protected $pharmacode = '';

    /**
     * searchString
     *
     * @var string
     */
    protected $searchString = '';

    /**
     * name
     *
     * @var string
     */
    protected $brand = '';

    /**
     * name
     *
     * @var string
     */
    protected $googleProductCategory = '';

	/**
	 * description
	 *
	 * @var string
	 */
	protected $description = '';

	/**
	 * price
	 *
	 * @var float
	 */
	protected $price;

    /**
     * discount
     *
     * @var float
     */
    protected $discount;

    /**
     * discountStart
     *
     * @var \DateTime
     */
    protected $discountStart;

    /**
     * discountEnd
     *
     * @var \DateTime
     */
    protected $discountEnd;

	/**
	 * priceLabel
	 *
	 * @var string
	 */
	protected $priceLabel;

	/**
	 * priceEuro
	 *
	 * @var float
	 */
	protected $priceEuro;

	/**
	 * priceMember
	 *
	 * @var float
	 */
	protected $priceMember;

	/**
	 * priceMemberEuro
	 *
	 * @var float
	 */
	protected $priceMemberEuro;

	/**
	 * image
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade remove
	 */
	protected $image = NULL;

	/**
	 * imageThumb
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $imageThumb = NULL;

	/**
	 * sorting
	 *
	 * @var integer
	 */
	protected $sorting = 0;

	/**
	 * noPorto
	 *
	 * @var boolean
	 */
	protected $noPorto = FALSE;

	/**
	 * imageThumbTitle
	 *
	 * @var string
	 */
	protected $imageThumbTitle = '';

	/**
	 * productInfo
	 *
	 * @var string
	 */
	protected $productInfo = '';

	/**
	 * active
	 *
	 * @var boolean
	 */
	protected $onlySwiss = FALSE;

	/**
	 * maxAmount
	 *
	 * @var integer
	 */
	protected $maxAmount = 0;

    /**
     * releaseYear
     *
     * @var integer
     */
    protected $releaseYear = 0;

    /**
     * pages
     *
     * @var integer
     */
    protected $pages = 0;

	/**
	 * optionsSize
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionSize>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $optionsSize = NULL;

    /**
     * optionsPackaging
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionPackaging>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $optionsPackaging = NULL;

	/**
	 * category
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Category>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $category = NULL;

    /**
     * productClass
     * @var \InternetGalerie\Igshop2\Domain\Model\ProductClass
     */
    protected $productClass = null;

	/**
	 * optionsColor
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionColor>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $optionsColor = NULL;

	/**
	 * optionEntry
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionGroup>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $optionEntry = NULL;

	/**
	 * optionsInput
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionInput>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $optionsInput = NULL;

	/**
	 * optionsSize
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Product>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $optionsProducts = NULL;

    /**
     * optionsProductsAmount
     *
     * @var integer
     */
    protected $optionsProductsAmount = 0;

    /**
     * optionEntry
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Product>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $products = NULL;

	/**
	 * prices
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Productprice>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade remove
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $prices = NULL;

	/**
	 * optionsWithPrice
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionWithPrice>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade remove
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $optionsWithPrice = NULL;

	/**
	 * videos
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Video>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade remove
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $videos = NULL;

	/**
	 * files
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade remove
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $files = NULL;

	/**
	 * siteId
	 *
	 * @var int
	 */
	protected $siteId = 0;

	/**
	 * mandantUid
	 *
	 * @var int
	 */
	protected $mandantUid = 0;



	/**
	 * fileRepository
	 *
	 * @var \TYPO3\CMS\Core\Resource\FileRepository
	 */
	protected $fileRepository=null;

	/**
         * optionWithPriceRepository
         *
         * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionWithPrice>
         * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
         */
	public $resOptionSizePrice=null;

    /**
     * _languageUid
     * @var ?int
     */
    protected $_languageUid;

    /**
     * _localizedUid
     * @var ?int
     */
    protected $_localizedUid;

    /**
     * state
     * @var \InternetGalerie\Igshop2\Domain\Model\State
     */
    protected $state = null;

    /**
     * deliveryPeriod
     * @var \InternetGalerie\Igshop2\Domain\Model\DeliveryPeriod
     */
    protected $deliveryPeriod = null;

    /**
     * width
     *
     * @var double
     */
    protected $width = '';

    /**
     * height
     *
     * @var double
     */
    protected $height = '';

    /**
     * depth
     *
     * @var double
     */
    protected $depth = '';

    /**
     * weight
     *
     * @var double
     */
    protected $weight = '';

    /**
     * material
     *
     * @var string
     */
    protected $material = '';

    /**
     * additional
     *
     * @var string
     */
    protected $additional = '';

    /**
     * standardCosts
     *
     * @var double
     */
    protected $standardCosts = 0.0;

    /**
     * priceDescription
     *
     * @var string
     */
    protected $priceDescription = '';

    /**
     * variants
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Productvariant>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    protected $variants = null;

    /**
     * relatedCategory
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Category>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $relatedCategory = null;

    /**
     * vergriffen
     * @var boolean
     */
    protected $vergriffen = false;

	protected string $propertiesDescriptionTop = '';
	protected string $propertiesDescriptionBottom = '';
	protected string $containedAccessoriesDescriptionTop = '';
	protected string $containedAccessoriesDescriptionBottom = '';
	protected string $additionalAccessoriesDescriptionTop = '';
	protected string $additionalAccessoriesDescriptionBottom = '';
	protected string $contentDescriptionTop = '';
	protected string $contentDescriptionBottom = '';

	/**
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Propertyvalue>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected ?ObjectStorage $properties = null;

	/**
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Product>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected ?ObjectStorage $containedAccessories = null;

	/**
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Product>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected ?ObjectStorage $additionalAccessories = null;

    /**
     * contentElementsCols
     * @var int
     */
    protected $contentElementsCols = false;

	/**
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\GeorgRinger\News\Domain\Model\TtContent>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $contentElements;

	/**
	 * productOfMonth
	 *
	 * @var boolean
	 */
	protected $productOfMonth = false;

	/**
	 * __construct
	 */
	public function __construct() {
		//Do not remove the next line: It would break the functionality
		$this->initStorageObjects();
	}

	/**
	 * Initializes all ObjectStorage properties
	 * Do not modify this method!
	 * It will be rewritten on each save in the extension builder
	 * You may modify the constructor of this class instead
	 *
	 * @return void
	 */
	protected function initStorageObjects() {
		$this->image = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->imageThumb = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->optionsSize = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->category = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->relatedCategory = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->products = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->optionsColor = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->optionEntry = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->optionsInput = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->prices = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->optionsWithPrice = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->videos = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->properties = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->containedAccessories = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->additionalAccessories = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
	}

        protected function getLocalized( $attribute ) {
          $uidLang =  GeneralUtility::makeInstance(Context::class)->getPropertyFromAspect('language', 'id') > 0 ? $this->_getProperty('_localizedUid') : $this->getUid();

          if( $this->fileRepository===null)
              $this->fileRepository = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Core\\Resource\\FileRepository');
          $falTrans = $this->fileRepository->findByRelation('tx_igshop2_domain_model_product', $attribute, $uidLang);
          return $falTrans;
        }
	/**
	 * Returns the productid
	 *
	 * @return string $productid
	 */
	public function getProductid() {
		return $this->productid;
	}

	/**
	 * Sets the productid
	 *
	 * @param string $productid
	 * @return void
	 */
	public function setProductid($productid) {
		$this->productid = $productid;
	}

	/**
	 * Returns the name
	 *
	 * @return string $name
	 */
	public function getName() {
		return $this->name;
	}

	/**
	 * Sets the name
	 *
	 * @param string $name
	 * @return void
	 */
	public function setName($name) {
		$this->name = $name;
	}

    /**
     * Returns the brand
     *
     * @return string $brand
     */
    public function getBrand() {
        return $this->brand;
    }

    /**
     * Sets the brand
     *
     * @param string $brand
     * @return void
     */
    public function setBrand($brand) {
        $this->brand = $brand;
    }

    /**
     * Returns the gtin
     *
     * @return string $gtin
     */
    public function getGtin() {
        return $this->gtin;
    }

    /**
     * Sets the gtin
     *
     * @param string $gtin
     * @return void
     */
    public function setGtin($gtin) {
        $this->gtin = $gtin;
    }

    /**
     * Returns the mpn
     *
     * @return string $mpn
     */
    public function getMpn() {
      return $this->mpn;
    }

    /**
     * Sets the mpn
     *
     * @param string $mpn
     * @return void
     */
    public function setMpn($mpn) {
      $this->mpn = $mpn;
    }

    /**
     * Returns the pharmacode
     *
     * @return string $pharmacode
     */
    public function getPharmacode() {
      return $this->pharmacode;
    }

    /**
     * Sets the pharmacode
     *
     * @param string $pharmacode
     * @return void
     */
    public function setPharmacode($pharmacode) {
      $this->pharmacode = $pharmacode;
    }

    /**
     * Sets the searchString
     *
     * @param string $searchString
     * @return void
     */
    public function setSearchString($searchString) {
      $this->searchString = $searchString;
    }

    /**
     * Returns the searchString
     *
     * @return string $searchString
     */
    public function getSearchString() {
      return $this->searchString;
    }

    /**
     * Returns the googleProductCategory
     *
     * @return string $googleProductCategory
     */
    public function getGoogleProductCategory() {
        return $this->googleProductCategory;
    }

    /**
     * Sets the googleProductCategory
     *
     * @param string $googleProductCategory
     * @return void
     */
    public function setGoogleProductCategory($googleProductCategory) {
        $this->googleProductCategory = $googleProductCategory;
    }

	/**
	 * Returns the description
	 *
	 * @return string $description
	 */
	public function getDescription() {
		return $this->description;
	}

	/**
	 * Sets the description
	 *
	 * @param string $description
	 * @return void
	 */
	public function setDescription($description) {
		$this->description = $description;
	}

	/**
	 * Returns the name
	 *
	 * @return string $name
	 */
	public function getProductInfo() {
		return $this->productInfo;
	}

	/**
	 * Sets the ProductInfo
	 *
	 * @param string $productInfo
	 * @return void
	 */
	public function setProductInfo($productInfo) {
		$this->productInfo = $productInfo;
	}

	/**
	 * Returns the imageThumbTitle
	 *
	 * @return string $imageThumbTitle
	 */
	public function getImageThumbTitle() {
		return $this->imageThumbTitle;
	}

	/**
	 * Sets the imageTitle
	 *
	 * @param string $imageThumbTitle
	 * @return void
	 */
	public function setImageThumbTitle($imageThumbTitle) {
		$this->imageThumbTitle = $imageThumbTitle;
    }

	/**
	 * Returns the price
	 *
	 * @return float $price
	 */
	public function getPrice() {
		return $this->price;
    }

	/**
	 * Sets the price
	 *
	 * @param float $price
	 * @return void
	 */
	public function setPrice($price) {
		$this->price = $price;
	}

    /**
     * Returns the discount
     *
     * @return float $discount
     */
    public function getDiscount()
    {
        return $this->discount;
    }

    /**
     * Returns the discount
     */
    public function setDiscount($discount)
    {
        $this->discount = $discount;;
    }

    /**
     * Returns the discountStart
     *
     * @return \DateTime $discountStart
     */
    public function getDiscountStart()
    {
        return $this->discountStart;
    }

    public function setDiscountStart(?\DateTime $discountStart)
    {
        $this->discountStart = $discountStart;
    }

    /**
     * Returns the discountEnd
     *
     * @return \DateTime $discountEnd
     */
    public function getDiscountEnd()
    {
        return $this->discountEnd;
    }

    public function setDiscountEnd(?\DateTime $discountEnd)
    {
        $this->discountEnd = $discountEnd;
    }

	/**
	 * Returns the priceEuro
	 *
	 * @return float $priceEuro
	 */
	public function getPriceEuro() {
		return $this->priceEuro;
	}

	/**
	 * Sets the priceEuro
	 *
	 * @param float $priceEuro
	 * @return void
	 */
	public function setPriceEuro($priceEuro) {
		$this->priceEuro = $priceEuro;
	}

	/**
	 * Returns the priceMember
	 *
	 * @return float $priceMember
	 */
	public function getPriceMember() {
		return $this->priceMember;
	}

    public function getHasPriceMember() {
        if($this->priceMember === null) {
            return false;
        }

        return true;
    }

	/**
	 * Sets the priceMember
	 *
	 * @param float $priceMember
	 * @return void
	 */
	public function setPriceMember($priceMember) {
		$this->priceMember = $priceMember;
	}

	/**
	 * Returns the priceMemberEuro
	 *
	 * @return float $priceMemberEuro
	 */
	public function getPriceMemberEuro() {
		return $this->priceMemberEuro;
	}

	/**
	 * Sets the priceMemberEuro
	 *
	 * @param float $priceMemberEuro
	 * @return void
	 */
	public function setPriceMemberEuro($priceMemberEuro) {
		$this->priceMemberEuro = $priceMemberEuro;
	}

	/**
	 * Returns the SiteId
	 *
	 * @return integer $siteId
	 */
	public function getSiteId() {
		return $this->siteId;
	}

	/**
	 * Sets the SiteId
	 *
	 * @param integer $relevance
	 * @return void
	 */
	public function setSiteId($siteId) {
		$this->siteId = $siteId;
	}


	/**
	 * Returns the MandantUid
	 *
	 * @return integer $mandantUid
	 */
	public function getMandantUid() {
		return $this->mandantUid;
	}

	/**
	 * Sets the MandantUid
	 *
	 * @param integer $relevance
	 * @return void
	 */
	public function setMandantUid($mandantUid) {
		$this->mandantUid = $mandantUid;
	}


    /**
	 * Adds a FileReference
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $image
	 * @return void
	 */
	public function addImage(\TYPO3\CMS\Extbase\Domain\Model\FileReference $image) {
		$this->image->attach($image);
	}

	/**
	 * Removes a FileReference
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $imageToRemove The FileReference to be removed
	 * @return void
	 */
	public function removeImage(\TYPO3\CMS\Extbase\Domain\Model\FileReference $imageToRemove) {
		$this->image->detach($imageToRemove);
	}

	/**
	 * Returns the image
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
	 */
	public function getImage() {
		return $this->image;
	}
        /**
         * Returns the imageLocalized
         *
         * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
         */
        public function getImageLocalized() {
	  //return $this->getImage();
          return $this->getLocalized( 'image' );
        }

	/**
	 * Returns the mainimage
	 *
	 * @return \TYPO3\CMS\Extbase\Domain\Model\FileReference $image
	 */
	public function getMainImageLocalized() {
	  $imgs = $this->getImageLocalized();
	  return count($imgs) >0 ? $imgs[0] : null;
	}


	/**
	 * Sets the image
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
	 * @return void
	 */
	public function setImage(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $image) {
		$this->image = $image;
	}

    /**
     * Adds a FileReference
     *
     * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $imageThumb
     * @return void
     */
    public function addImageThumb(\TYPO3\CMS\Extbase\Domain\Model\FileReference $imageThumb) {
        $this->image->attach($imageThumb);
    }

    /**
     * Removes a FileReference
     *
     * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $imageThumbToRemove The FileReference to be removed
     * @return void
     */
    public function removeImageThumb(\TYPO3\CMS\Extbase\Domain\Model\FileReference $imageThumbToRemove) {
        $this->image->detach($imageThumbToRemove);
    }

	/**
	 * Returns the imageThumb
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $imageThumb
	 */
	public function getImageThumb() {
		return $this->imageThumb;
	}
        /**
         * Returns the thumbImageLocalized
         *
         * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
         */
        public function getImageThumbLocalized() {
	  //return $this->getImageThumb();
          return $this->getLocalized( 'image_thumb' );
        }


	/**
	 * Sets the imageThumb
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference>
	 * @return void
	 */
	public function setImageThumb(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $imageThumb) {
		$this->imageThumb = $imageThumb;
	}

	/**
	 * Adds a FileReference
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $image
	 * @return void
	 */
	public function addFiles(\TYPO3\CMS\Extbase\Domain\Model\FileReference $files) {
		$this->files->attach($files);
	}

	/**
	 * Removes a FileReference
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $filesToRemove The FileReference to be removed
	 * @return void
	 */
	public function removeFiles(\TYPO3\CMS\Extbase\Domain\Model\FileReference $filesToRemove) {
		$this->image->detach($filesToRemove);
	}

	/**
	 * Returns the image
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
	 */
	public function getFiles() {
		return $this->files;
	}

	/**
	 * Sets the files
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $files
	 * @return void
	 */
	public function setFiles(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $files) {
		$this->files = $files;
	}

	/**
	 * Returns the noPorto
	 *
	 * @return boolean $noPorto
	 */
	public function getNoPorto() {
		return $this->noPorto;
	}

	/**
	 * Sets the noPorto
	 *
	 * @param boolean $noPorto
	 * @return void
	 */
	public function setNoPorto($noPorto) {
		$this->noPorto = $noPorto;
	}

	/**
	 * Returns the boolean state of noPorto
	 *
	 * @return boolean
	 */
	public function isNoPorto() {
		return $this->noPorto;
	}

	/**
	 * Returns the sorting
	 *
	 * @return integer $sorting
	 */
	public function getSorting() {
		return $this->sorting;
	}

	/**
	 * Sets the sorting
	 *
	 * @param integer $sorting
	 * @return void
	 */
	public function setSorting($sorting) {
		$this->sorting = $sorting;
	}

	/**
	 * Returns the maxAmount
	 *
	 * @return integer $maxAmount
	 */
	public function getMaxAmount() {
		return $this->maxAmount;
	}

	/**
	 * Sets the maxAmount
	 *
	 * @param integer $maxAmount
	 * @return void
	 */
	public function setMaxAmount($maxAmount) {
		$this->maxAmount = $maxAmount;
	}

    /**
     * Returns the pages
     *
     * @return integer $pages
     */
    public function getPages() {
        return $this->pages;
    }

    /**
     * Sets the pages
     *
     * @param integer $pages
     * @return void
     */
    public function setpages($pages) {
        $this->pages = $pages;
    }

    /**
     * Returns the releaseYear
     *
     * @return integer $releaseYear
     */
    public function getReleaseYear() {
        return $this->releaseYear;
    }

    /**
     * Sets the releaseYear
     *
     * @param integer $releaseYear
     * @return void
     */
    public function setReleaseYear($releaseYear) {
        $this->releaseYear = $releaseYear;
    }

	/**
	 * Adds a OptionSize
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\OptionSize $optionsSize
	 * @return void
	 */
	public function addOptionsSize(\InternetGalerie\Igshop2\Domain\Model\OptionSize $optionsSize) {
		$this->optionsSize->attach($optionsSize);
	}

	/**
	 * Removes a OptionSize
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\OptionSize $optionsSizeToRemove The OptionSize to be removed
	 * @return void
	 */
	public function removeOptionsSize(\InternetGalerie\Igshop2\Domain\Model\OptionSize $optionsSizeToRemove) {
		$this->optionsSize->detach($optionsSizeToRemove);
	}

	/**
	 * Returns the optionsSize
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionSize> $optionsSize
	 */
	public function getOptionsSize() {
		return $this->optionsSize;
	}

	/**
	 * Sets the optionsSize
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionSize> $optionsSize
	 * @return void
	 */
	public function setOptionsSize(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $optionsSize) {
		$this->optionsSize = $optionsSize;
	}

    /**
     * Adds a OptionPackaging
     *
     * @param \InternetGalerie\Igshop2\Domain\Model\OptionPackaging $optionsPackaging
     * @return void
     */
    public function addOptionsPackaging(\InternetGalerie\Igshop2\Domain\Model\OptionPackaging $optionsPackaging) {
        $this->optionsPackaging->attach($optionsPackaging);
    }

    /**
     * Removes a OptionPackaging
     *
     * @param \InternetGalerie\Igshop2\Domain\Model\OptionPackaging $optionsPackagingToRemove The OptionPackaging to be removed
     * @return void
     */
    public function removeOptionsPackaging(\InternetGalerie\Igshop2\Domain\Model\OptionPackaging $optionsPackagingToRemove) {
        $this->optionsPackaging->detach($optionsPackagingToRemove);
    }

    /**
     * Returns the optionsPackaging
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionPackaging> $optionsPackaging
     */
    public function getOptionsPackaging() {
        return $this->optionsPackaging;
    }

    /**
     * Sets the optionsPackaging
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionPackaging> $optionsPackaging
     * @return void
     */
    public function setOptionsPackaging(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $optionsPackaging) {
        $this->optionsPackaging = $optionsPackaging;
    }

    /**
     * Adds a Product
     *
     * @param \InternetGalerie\Igshop2\Domain\Model\Product $product
     * @return void
     */
    public function addProduct(\InternetGalerie\Igshop2\Domain\Model\Product $product) {
        $this->products->attach($product);
    }

    /**
     * Removes a product
     *
     * @param \InternetGalerie\Igshop2\Domain\Model\Product $product The Product to be removed
     * @return void
     */
    public function removeProduct(\InternetGalerie\Igshop2\Domain\Model\Product $product) {
        $this->products->detach($product);
    }

    /**
     * Returns the products
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Product> $product
     */
    public function getProducts() {
        return $this->products;
    }

    /**
     * Sets the producuts
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Product> $products
     * @return void
     */
    public function setProducts(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $products) {
        $this->products = $products;
    }

	/**
	 * Adds a Category
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Category $category
	 * @return void
	 */
	public function addCategory(\InternetGalerie\Igshop2\Domain\Model\Category $category) {
		$this->category->attach($category);
	}

	/**
	 * Removes a Category
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Category $categoryToRemove The Category to be removed
	 * @return void
	 */
	public function removeCategory(\InternetGalerie\Igshop2\Domain\Model\Category $categoryToRemove) {
		$this->category->detach($categoryToRemove);
	}

	/**
	 * Returns the category
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Category> $category
	 */
	public function getCategory() {
		return $this->category;
	}
	public function getCategoryFirst() {
        foreach($this->getCategory() as $category) {
            if( !$category->isExcludeSlug()) {
                return $category;
            }
        }
		return null;
	}
	public function hasCategoryIn(array $categoryUids) {
        foreach($this->category as $category) {
            if(in_array($category->getUid(), $categoryUids)) {
                return true;
            }
        }
        return false;
    }
	/**
	 * Sets the category
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Category> $category
	 * @return void
	 */
	public function setCategory(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $category) {
		$this->category = $category;
	}

    /**
     * Returns the productClass
     *
     * @return \InternetGalerie\Igshop2\Domain\Model\ProductClass $productClass
     */
    public function getProductClass() {
        return $this->productClass;
    }

    /**
     * Sets the productClass
     *
     * @param \InternetGalerie\Igshop2\Domain\Model\ProductClass $productClass
     * @return void
     */
    public function setProductClass(\InternetGalerie\Igshop2\Domain\Model\ProductClass $productClass) {
        $this->productClass = $productClass;
    }
	/**
	 * Returns the first Top level category otherwise the top level category of the first category
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Category> $category
	 */
	public function getCategoryTopLevel() {
	  foreach( $this->getCategory() as $cat ) {
          if( $cat->getParent()==0 && $cat->getExcludeSlug()==0)
	      return $cat;
	  }
	  foreach( $this->getCategory() as $cat ) {
          $p=$cat->getParent();
          if( $p && $p->getParent()==0) {
              return $p;
          }
	  }
	  return null;
	}

    public function getFirstCategoryTopLevel() {
        if( $this->getCategory()->count() > 0) {
            foreach($this->getCategory() as $category) {
                if( $category->isExcludeSlug()) {
                    continue;
                }
                $topCategory=$category->getTopCategory();
                if( !$topCategory->isExcludeSlug()) {
                    return $topCategory;
                }
            }
        } else {
            return null;
        }
        /*

        if(!$category && $this->getCategory()) {
            $category = $this->getCategory()[0];
        } else if(!$category) {
            return null;
        }

        $parent = $category->getParent();

        if($parent) {
            return $this->getFirstCategoryTopLevel($parent);
        }

        return $category;
        */
    }


	/**
	 * Adds a OptionColor
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\OptionColor $optionsColor
	 * @return void
	 */
	public function addOptionsColor(\InternetGalerie\Igshop2\Domain\Model\OptionColor $optionsColor) {
		$this->optionsColor->attach($optionsColor);
	}

	/**
	 * Removes a OptionColor
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\OptionColor $optionsColorToRemove The OptionColor to be removed
	 * @return void
	 */
	public function removeOptionsColor(\InternetGalerie\Igshop2\Domain\Model\OptionColor $optionsColorToRemove) {
		$this->optionsColor->detach($optionsColorToRemove);
	}

	/**
	 * Returns the optionsColor
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionColor> $optionsColor
	 */
	public function getOptionsColor() {
		return $this->optionsColor;
	}

	/**
	 * Sets the optionsColor
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionColor> $optionsColor
	 * @return void
	 */
	public function setOptionsColor(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $optionsColor) {
		$this->optionsColor = $optionsColor;
	}


	/**
	 * Adds a Product
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Product $product
	 * @return void
	 */
	public function addOptionsProduct(\InternetGalerie\Igshop2\Domain\Model\Product $product) {
		$this->optionsProducts->attach($product);
	}

	/**
	 * Removes a Product
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Product $productToRemove The OptionColor to be removed
	 * @return void
	 */
	public function removeOptionsProduct(\InternetGalerie\Igshop2\Domain\Model\Product $productToRemove) {
		$this->optionsProducts->detach($productToRemove);
	}

	/**
	 * Returns the optionsProducts
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Product> $optionsProducts
	 */
	public function getOptionsProducts() {
		return $this->optionsProducts;
	}

	/**
	 * Sets the optionsProducts
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Product> $optionsProducts
	 * @return void
	 */
	public function setOptionsProducts(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $optionsProducts) {
		$this->optionsProducts = $optionsProducts;
	}

	/**
	 * Adds a OptionGroup
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\OptionGroup $optionEntry
	 * @return void
	 */
	public function addOptionEntry(\InternetGalerie\Igshop2\Domain\Model\OptionGroup $optionEntry) {
		$this->optionEntry->attach($optionEntry);
	}

	/**
	 * Removes a OptionGroup
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\OptionGroup $optionEntryToRemove The OptionGroup to be removed
	 * @return void
	 */
	public function removeOptionEntry(\InternetGalerie\Igshop2\Domain\Model\OptionGroup $optionEntryToRemove) {
		$this->optionEntry->detach($optionEntryToRemove);
	}

	/**
	 * Returns the optionEntry
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionGroup> $optionEntry
	 */
	public function getOptionEntry() {
		return $this->optionEntry;
	}

	/**
	 * Sets the optionEntry
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionGroup> $optionEntry
	 * @return void
	 */
	public function setOptionEntry(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $optionEntry) {
		$this->optionEntry = $optionEntry;
	}

	/**
	 * Adds a Productprice
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Productprice $price
	 * @return void
	 */
	public function addPrice(\InternetGalerie\Igshop2\Domain\Model\Productprice $price) {
		$this->prices->attach($price);
	}

	/**
	 * Removes a Productprice
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Productprice $priceToRemove The Productprice to be removed
	 * @return void
	 */
	public function removePrice(\InternetGalerie\Igshop2\Domain\Model\Productprice $priceToRemove) {
		$this->prices->detach($priceToRemove);
	}

	/**
	 * Returns the prices
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Productprice> $prices
	 */
	public function getPrices() {
		return $this->prices;
	}

	/**
	 * Sets the prices
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Productprice> $prices
	 * @return void
	 */
	public function setPrices(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $prices) {
		$this->prices = $prices;
	}

	/**
	 * Adds a OptionWithPrice
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\OptionWithPrice $optionsWithPrice
	 * @return void
	 */
	public function addOptionsWithPrice(\InternetGalerie\Igshop2\Domain\Model\OptionWithPrice $optionsWithPrice) {
		$this->optionsWithPrice->attach($optionsWithPrice);
	}

	/**
	 * Removes a OptionWithPrice
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\OptionWithPrice $optionsWithPriceToRemove The OptionWithPrice to be removed
	 * @return void
	 */
	public function removeOptionsWithPrice(\InternetGalerie\Igshop2\Domain\Model\OptionWithPrice $optionsWithPriceToRemove) {
		$this->optionsWithPrice->detach($optionsWithPriceToRemove);
	}

	/**
	 * Returns the optionsWithPrice
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionWithPrice> $optionsWithPrice
	 */
	public function getOptionsWithPrice() {
		return $this->optionsWithPrice;
	}
        /**
         * Returns the optionsWithPriceLocalized
         *
         * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionSizePrice> $optionsWithPriceLocalized
         */
        public function getOptionsWithPriceLocalized() {
          // eigentlich müsste man das TCA anpassen -> https://docs.typo3.org/typo3cms/TCAReference/Reference/Columns/Inline/Index.html#behaviour  localizationMode showSynchronizationLink =1
          /*
"behaviour" => array (
  "localizationMode" => "select"
)
	  */
          $uidLang =  GeneralUtility::makeInstance(Context::class)->getPropertyFromAspect('language', 'id') > 0 ? $this->_getProperty('_localizedUid') : $this->getUid();
		 $optionWithPriceRepository = GeneralUtility::makeInstance(OptionWithPriceRepository::class);
		  if($this->resOptionSizePrice===null)
            $this->resOptionSizePrice= $optionWithPriceRepository->findByProduct( $uidLang);
          return $this->resOptionSizePrice;
        }
        public function getOptionsWithPriceAll() {
          // eigentlich müsste man das TCA anpassen -> https://docs.typo3.org/typo3cms/TCAReference/Reference/Columns/Inline/Index.html#behaviour  localizationMode showSynchronizationLink =1
          /*
"behaviour" => array (
  "localizationMode" => "select"
)
	  */
          //$uidLang =  GeneralUtility::makeInstance(Context::class)->getPropertyFromAspect('language', 'id') > 0 ? $this->_getProperty('_localizedUid') : $this->getUid();

          // get all uids
          $uidList = [];
          $uidList[]=$this->getUid();
          $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable('tx_igshop2_domain_model_product');
          $res = $queryBuilder->select('uid')
          ->from('tx_igshop2_domain_model_product')
          ->where($queryBuilder->expr()->and(
            $queryBuilder->expr()->eq(
                'deleted',
                $queryBuilder->createNamedParameter('0')
            ),
            $queryBuilder->expr()->eq(
                'hidden',
                $queryBuilder->createNamedParameter('0')
            ),
            $queryBuilder->expr()->eq(
                'l10n_parent',
                $queryBuilder->createNamedParameter(intval($this->getUid()))
            )
          ))->executeQuery();
          //$res=$GLOBALS['TYPO3_DB']->exec_SELECTquery('uid','tx_igshop2_domain_model_product', 'deleted=0 AND hidden=0 AND l10n_parent= ' . intval($this->getUid()));
          //if( ( $d = $GLOBALS['TYPO3_DB']->sql_fetch_assoc( $res ))) {
          if(($d = $res->fetchAssociative())) {
            $uidList[]=$d['uid'];
          }

          //print_r($uidList);
          //$productRepository = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('InternetGalerie\Igshop2\Domain\Repository\ProductRepository');
          //$uidList= $productRepository->findUidList($this->getUid());
          //$e= $uidList->getFirst();
          //$uid_lang=$e->_getProperty('_localizedUid');
          $this->resOptionSizePrice = [];
          //      if($this->resOptionSizePrice===null) {
	  //$this->resOptionSizePrice= $this->optionWithPriceRepository->findByProduct( $uidLang);
			$optionWithPriceRepository = GeneralUtility::makeInstance(OptionWithPriceRepository::class);
          foreach( $uidList as $c=>$uid ) {
            foreach ($optionWithPriceRepository->findByProduct( $uid ) as $p ) {
              $this->resOptionSizePrice[] = $p;
            }
          }

          return $this->resOptionSizePrice;
        }

	/**
	 * Sets the optionsWithPrice
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionWithPrice> $optionsWithPrice
	 * @return void
	 */
	public function setOptionsWithPrice(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $optionsWithPrice) {
		$this->optionsWithPrice = $optionsWithPrice;
	}

	/**
	 * Adds a Video
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Video $video
	 * @return void
	 */
	public function addVideo(\InternetGalerie\Igshop2\Domain\Model\Video $video) {
		$this->videos->attach($video);
	}

	/**
	 * Removes a Video
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Video $videoToRemove The Video to be removed
	 * @return void
	 */
	public function removeVideo(\InternetGalerie\Igshop2\Domain\Model\Video $videoToRemove) {
		$this->videos->detach($videoToRemove);
	}

	/**
	 * Returns the videos
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Video> $videos
	 */
	public function getVideos() {
		return $this->videos;
	}

	/**
	 * Sets the videos
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Video> $videos
	 * @return void
	 */
	public function setVideos(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $videos) {
		$this->videos = $videos;
	}

	public function hasActionPrice($currency){
		return (is_array($this->getFinalPrice($currency, null, 0, true)));
	}

	/**
	 * Returns the onlySwiss
	 *
	 * @return boolean $onlySwiss
	 */
	public function getOnlySwiss() {
		return $this->onlySwiss;
	}

	/**
	 * Sets the onlySwiss
	 *
	 * @param boolean $onlySwiss
	 * @return void
	 */
	public function setOnlySwiss($onlySwiss) {
		$this->onlySwiss = $onlySwiss;
	}

	/**
	 * Returns the boolean state of onlySwiss
	 *
	 * @return boolean
	 */
	public function isOnlySwiss() {
		return $this->onlySwiss;
	}

	/**
	 * Returns the correct price, if there is set a special price order the customer is a member
	 * @param \InternetGalerie\Igshop2\Domain\Model\Currency $currency
	 * @param int $optionWithPriceUid
	 * @param int $amount
	 * @param boolean $checkForPromotion
	 * @return float
	 *
	 */
	public function getFinalPrice($currency, $optionWithPriceUid = null, $amount = 0, $checkForPromotion = false, $isMember = false) {
		if($this->onlySwiss && $currency->getShort() != "CHF"){
			return null;
		}
        $context = GeneralUtility::makeInstance(Context::class);

		$memberGroups = $context->getPropertyFromAspect('frontend.user', 'groupIds');
		$prices = [];
		// Finde den Normalpreis (nicht eingeloggt od. eingeloggt, EuroPreis od. andere Währung)
		$prices[] = $this -> getDefaultPrices($memberGroups, $currency, $isMember);
		//Preise nach Optionen, welche einen Preis beinhalten
		if($this->optionsWithPrice && $optionWithPriceUid > 0){
			foreach($this->optionsWithPrice AS $optionWithPrice){
			  $uidLang =  GeneralUtility::makeInstance(Context::class)->getPropertyFromAspect('language', 'id') > 0 ? $optionWithPrice->_getProperty('_localizedUid') : $optionWithPrice->getUid();

			  //echo('[('.$this->getUid().')'.$optionWithPriceUid.'=='.$optionWithPrice->getUid().'=='.$uidLang.']');
				if($optionWithPrice->getUid() == $optionWithPriceUid){
					return $optionWithPrice->getOptionPrice($currency, $amount);
				}
			}
		}
		// Finde alle PreisOptionen, die zutreffen
		$optionalPrices = $this->getPossibleOptionalPrices($currency, $memberGroups, $amount);

		// Wenn Mengenrabatt, filtere aus
		if($amount > 0){
			$quantityDiscountPrice = $this->getQuantitydiscountPrice($optionalPrices, $amount, $currency);
			if($quantityDiscountPrice > 0)
				$prices[] = $quantityDiscountPrice;
		}

		$isActionPrice = false;
		foreach($optionalPrices AS $price){
			if($price->isIsSpecialPrice()){
				if($this->takeEuroPrice($currency->getShort(), $price->getPriceEuro())){
					if(min($prices) > $price->getEuroPrice)
						$isActionPrice = true;

					$prices[] = $price->getPriceEuro();
				}else{
					if(min($prices) > $price->getPrice() * $currency->getFaktor())
						$isActionPrice = true;

					$prices[] = $price->getPrice() * $currency->getFaktor();
				}
			}
		}

        // Add discount
        $discount = $this->getDiscount();
        $discountStart = $this->getDiscountStart();
        if($discountStart) {
            $discountStart->setTime(0, 0, 0);
        }
        $discountEnd = $this->getDiscountEnd();
        if ($discountEnd) {
            $discountEnd->setTime(23, 59, 59);
        }
        $now = new \DateTime();

        if ($discount && (($discountStart && $discountStart <= $now) || !$discountStart) && (($discountEnd && $discountEnd >= $now) || !$discountEnd)) {
            $discountedPrice = 0;
            if ($this->takeEuroPrice($currency->getShort(), $this->getPriceEuro())) {
                $discountedPrice = $this->getPriceEuro();
            } else {
                $discountedPrice = $this->getPrice() * $currency->getFaktor();
            }
            $discountDecimal = $discount * 0.01;
            $discountAmount = $discountedPrice * $discountDecimal;
            $discountedPrice -= $discountAmount;
            if (min($prices) > $discountedPrice)
                $isActionPrice = true;
            $prices[] = $discountedPrice;
        }

		if($checkForPromotion && $isActionPrice){
			$origPrice = 0;
			if($this->getPriceEuro($this-> priceEuro)){
				$origPrice = $this -> priceEuro;
			}else{
				$origPrice = $this -> price * $currency->getFaktor();
			}
			return ["price" => min($prices), "state" => "isPromotion", "origPrice" => $origPrice];
		}
        
		return min($prices);
	}

	/**
	 * Check all Optional Prices if there is a Quantitydiscount an return one
	 * @param array $quantityDiscounts
	 * @param int $quantity
	 * @param \InternetGalerie\Igshop2\Domain\Model\Porto $porto
	 * @return \InternetGalerie\Igshop2\Domain\Model\Productprice $productprice
	 */
	private function getQuantitydiscountPrice($quantityDiscounts, $quantity, $currency){
		$quantityDiscountPrice = null;

		foreach($quantityDiscounts AS $key => $price){
			if($price->getAmount() > 0 && $quantity >= $price->getAmount()){
				if(is_object($quantityDiscountPrice)){
					if($quantityDiscountPrice->getAmount() <= $price->getAmount()){
						$quantityDiscountPrice = $price;
					}
				}else{
					$quantityDiscountPrice = $price;
				}
			}
		}

		if(is_object($quantityDiscountPrice)){
			if($this->takeEuroPrice($currency->getShort(), $quantityDiscountPrice->getPriceEuro())){
				return $quantityDiscountPrice->getPriceEuro();
			}else{
				return $quantityDiscountPrice->getPrice() * $currency->getFaktor();
			}
		}
	}

	/**
	 * Gets all ProductPrices, filtered by member Groups, and returns them as array
	 * @param \InternetGalerie\Igshop2\Domain\Model\Currency $currency
	 * @param array $memberGroups
	 * @return array
	 */
	private function getPossibleOptionalPrices($currency, $memberGroups){
		$return = [];
		if(count($memberGroups) > 0 && $memberGroups[0] != null){
			foreach($this->prices AS $price){
				$priceGroups = $price->getUserGroups()->toArray();
				if(empty($priceGroups)){
					$return[] = $price;
				}else{
					foreach ($priceGroups AS $group) {
						if (in_array($group -> getUid(), $memberGroups)) {
							$return[] = $price;
						}
					}
				}
			}
		}else{
			// Wenn Benutzer nicht eingeloggt
			foreach($this->prices AS $price){
				$priceGroups = $price->getUserGroups()->toArray();
				if (count($priceGroups) == 0) {
					$return[] = $price;
				}
			}
		}

		return $return;
	}

	/**
	 * Check if the EuroPrice Should be taken or the Original Price with Currency calculation
	 * @param string $currencyShort
	 * @param mixed $price
	 * @return boolean
	 */
	private function takeEuroPrice($currencyShort, $price){
		return ($currencyShort == "EUR" && $price !== null);
	}


	/**
	 * Returns the correct default Price - one of these HAS TO be set
	 * @param array $memberGroups
	 * @param \InternetGalerie\Igshop2\Domain\Model\Currency $currency
	 */
	private function getDefaultPrices($memberGroups, $currency, $isMember = false){
        $hasMemberGroups = false;
        if(!empty($memberGroups)) {
            foreach($memberGroups as $memberGroup) {
                if($memberGroup>0) {
                    $hasMemberGroups = true;
                    break;
                }
            }
        }
		if(($hasMemberGroups || $isMember) && $this->priceMember !== null) {
			if($this->takeEuroPrice($currency->getShort(), $this-> priceMemberEuro)){
				return $this -> priceMemberEuro;
			}else{
				return $this -> priceMember * $currency->getFaktor();
			}
		}else{
			if($this->takeEuroPrice($currency->getShort(), $this-> priceEuro)){
				return $this -> priceEuro;
			}else{
				return $this -> price * $currency->getFaktor();
			}
		}
	}

    /**
     * @param int $_languageUid
     * @return void
     */
    public function set_languageUid($_languageUid) {
      $this->_languageUid = $_languageUid;
    }

    /**
     * @return int
     */
    public function get_languageUid() {
      return $this->_languageUid;
    }
    /**
     * @param int $_localizedUid
     * @return void
     */
    public function set_localizedUid($_localizedUid) {
      $this->_localizedUid = $_localizedUid;
    }

    /**
     * @return int
     */
    public function get_localizedUid() {
      return $this->_localizedUid;
    }

    /**
     * @return \InternetGalerie\Igshop2\Domain\Model\State
     */
    public function getState(){
        return $this->state;
    }

    /**
     * @param \InternetGalerie\Igshop2\Domain\Model\State $state
     * @return void
     */
    public function setState(\InternetGalerie\Igshop2\Domain\Model\State $state){
        $this->state = $state;
    }

    /**
     * @return \InternetGalerie\Igshop2\Domain\Model\DeliveryPeriod
     */
    public function getDeliveryPeriod(){
        return $this->deliveryPeriod;
    }

    /**
     * @param \InternetGalerie\Igshop2\Domain\Model\State $state
     * @return void
     */
    public function setDeliveryPeriod($deliveryPeriod){
        $this->deliveryPeriod = $deliveryPeriod;
    }

    /**
     * @return double
     */
    public function getWidth(){
        return $this->width;
    }

    /**
     * @param double
     * @return void
     */
    public function setWidth($width){
        $this->width = $width;
    }

    /**
     * @return double
     */
    public function getHeight(){
        return $this->height;
    }

    /**
     * @param double
     * @return void
     */
    public function setHeight($height){
        $this->height = $height;
    }

    /**
     * @return double
     */
    public function getDepth(){
        return $this->depth;
    }

    /**
     * @param double
     * @return void
     */
    public function setDepth($depth){
        $this->depth = $depth;
    }

    /**
     * @return double
     */
    public function getWeight(){
        return $this->weight;
    }

    /**
     * @param double
     * @return void
     */
    public function setWeight($weight){
        $this->weight = $weight;
    }

    public function getHasInfoTable() {
        return $this->weight || $this->width || $this->height || $this->depth;
    }

    /**
     * Get the value of material
     *
     * @return string
     */
    public function getMaterial()
    {
        return $this->material;
    }

    /**
     * Set the value of material
     *
     * @param string material
     *
     * @return self
     */
    public function setMaterial($material)
    {
        $this->material = $material;

        return $this;
    }

    /**
     * Get the value of additional
     *
     * @return string
     */
    public function getAdditional()
    {
        return $this->additional;
    }

    /**
     * Set the value of additional
     *
     * @param string additional
     *
     * @return self
     */
    public function setAdditional($additional)
    {
        $this->additional = $additional;

        return $this;
    }

    /**
     * Get the value of standardCosts
     *
     * @return double
     */
    public function getStandardCosts()
    {
        return $this->standardCosts;
    }

    /**
     * Set the value of standardCosts
     *
     * @param double standardCosts
     *
     * @return self
     */
    public function setStandardCosts($standardCosts)
    {
        $this->standardCosts = $standardCosts;

        return $this;
    }

    /**
     * Returns the priceDescription
     *
     * @return string $priceDescription
     */
    public function getPriceDescription()
    {
        return $this->priceDescription;
    }

    /**
     * Sets the priceDescription
     *
     * @param string $priceDescription
     * @return void
     */
    public function setPriceDescription($priceDescription)
    {
        $this->priceDescription = $priceDescription;
    }

    /**
     * Adds a Productvariant
     *
     * @param \InternetGalerie\Igshop2\Domain\Model\Productvariant $variant
     * @return void
     */
    public function addVariant(\InternetGalerie\Igshop2\Domain\Model\Productvariant $variant)
    {
        $this->variants->attach($variant);
    }

    /**
     * Removes a Productvariant
     *
     * @param \InternetGalerie\Igshop2\Domain\Model\Productvariant $variantToRemove The Productvariant to be removed
     * @return void
     */
    public function removeVariant(\InternetGalerie\Igshop2\Domain\Model\Productvariant $variantToRemove)
    {
        $this->variants->detach($variantToRemove);
    }

    /**
     * Returns the variants
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Productvariant> $variants
     */
    public function getVariants()
    {
        return $this->variants;
    }

    /**
     * Sets the variants
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Productvariant> $variants
     * @return void
     */
    public function setVariants(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $variants)
    {
        $this->variants = $variants;
    }

	public function getRelatedProducts() {
        $relatedProducts=[];
        foreach($this->getCategory() as $category) {
            if( $category->isExcludeSlug()) {
                continue;
            }
            foreach( $category->getProducts() as $product) {
                $relatedProducts[]=$product;
            }
        }
		return $relatedProducts;
	}

    /**
     * Get the value of relatedCategory
     *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Category> $relatedCategory
     */
    public function getRelatedCategory()
    {
        return $this->relatedCategory;
    }

    /**
     * Set the value of relatedCategory
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Category> $relatedCategory
     *
     * @return self
     */
    public function setRelatedCategory(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $relatedCategory)
    {
        $this->relatedCategory = $relatedCategory;

        return $this;
    }

	/**
	 * Adds a relatedCategory
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Category $relatedCategory
	 * @return void
	 */
	public function addRelatedCategory(\InternetGalerie\Igshop2\Domain\Model\Category $relatedCategory) {
		$this->relatedCategory->attach($relatedCategory);
	}

	/**
	 * Removes a relatedCategory
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Category $relatedCategory The Category to be removed
	 * @return void
	 */
	public function removeRelatedCategory(\InternetGalerie\Igshop2\Domain\Model\Category $relatedCategory) {
		$this->relatedCategory->detach($relatedCategory);
	}


    /**
     * Get the value of optionWithPriceRepository
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionWithPrice>
     */
    public function getResOptionSizePrice()
    {
        return $this->resOptionSizePrice;
    }


    /**
     * Get the value of priceLabel
     *
     * @return string
     */
    public function getPriceLabel()
    {
        return $this->priceLabel;
    }

    /**
     * Set the value of priceLabel
     *
     * @param string $priceLabel
     *
     * @return self
     */
    public function setPriceLabel($priceLabel)
    {
        $this->priceLabel = $priceLabel;

        return $this;
    }


    /**
     * Get the value of optionsInput
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionInput>
     */
    public function getOptionsInput()
    {
        return $this->optionsInput;
    }

    /**
     * Set the value of optionsInput
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\OptionInput> $optionsInput
     *
     * @return self
     */
    public function setOptionsInput(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $optionsInput)
    {
        $this->optionsInput = $optionsInput;

        return $this;
    }



	/**
	 * Adds a OptionSize
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\OptionInput $optionsSize
	 * @return void
	 */
	public function addOptionsInput(\InternetGalerie\Igshop2\Domain\Model\OptionInput $optionsInput) {
		$this->optionsInput->attach($optionsInput);
	}

	/**
	 * Removes a OptionSize
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\OptionSize $optionsSizeToRemove The OptionSize to be removed
	 * @return void
	 */
	public function removeOptionsInput(\InternetGalerie\Igshop2\Domain\Model\OptionInput $optionsInputToRemove) {
		$this->optionsInput->detach($optionsInputToRemove);
	}


    /**
     * Get the value of vergriffen
     *
     * @return boolean
     */
    public function getVergriffen()
    {
        return $this->vergriffen;
    }

    /**
     * Set the value of vergriffen
     *
     * @param boolean $vergriffen
     *
     * @return self
     */
    public function setVergriffen($vergriffen)
    {
        $this->vergriffen = $vergriffen;

        return $this;
    }


    /**
     * Get the value of optionsProductsAmount
     *
     * @return integer
     */
    public function getOptionsProductsAmount()
    {
        return $this->optionsProductsAmount;
    }

    /**
     * Set the value of optionsProductsAmount
     *
     * @param integer $optionsProductsAmount
     *
     * @return self
     */
    public function setOptionsProductsAmount($optionsProductsAmount)
    {
        $this->optionsProductsAmount = $optionsProductsAmount;

        return $this;
    }

	public function setProperties(ObjectStorage $properties): void
	{
		$this->properties = $properties;
	}

	public function getProperties(): ?ObjectStorage
	{
		return $this->properties;
	}

	public function addProperty(Property $property)
	{
		$this->properties->attach($property);
	}

	public function hasProperty(Property $property)
	{
		return $this->properties->contains($property);
	}

	public function removeProperty(Property $property)
	{
		$this->properties->detach($property);
	}

	public function setContainedAccessories(ObjectStorage $containedAccessories): void
	{
		$this->containedAccessories = $containedAccessories;
	}

	public function getContainedAccessories(): ?ObjectStorage
	{
		return $this->containedAccessories;
	}

	public function addContainedAccessory(Product $containedAccessory)
	{
		$this->containedAccessories->attach($containedAccessory);
	}

	public function hasContainedAccessory(Product $containedAccessory)
	{
		return $this->containedAccessories->contains($containedAccessory);
	}

	public function removeContainedAccessory(Product $containedAccessory)
	{
		$this->containedAccessories->detach($containedAccessory);
	}

	public function setAdditionalAccessories(ObjectStorage $additionalAccessories): void
	{
		$this->additionalAccessories = $additionalAccessories;
	}

	public function getAdditionalAccessories(): ?ObjectStorage
	{
		return $this->additionalAccessories;
	}

	public function addAdditionalAccessory(Product $additionalAccessory)
	{
		$this->additionalAccessories->attach($additionalAccessory);
	}

	public function hasAdditionalAccessory(Product $additionalAccessory)
	{
		return $this->additionalAccessories->contains($additionalAccessory);
	}

	public function removeAdditionalAccessory(Product $additionalAccessory)
	{
		$this->additionalAccessories->detach($additionalAccessory);
	}


	/**
	 * Get the value of productOfMonth
	 *
	 * @return boolean
	 */
	public function getProductOfMonth()
	{
		return $this->productOfMonth;
	}

	/**
	 * Set the value of productOfMonth
	 *
	 * @param boolean $productOfMonth
	 *
	 * @return self
	 */
	public function setProductOfMonth($productOfMonth)
	{
		$this->productOfMonth = $productOfMonth;

		return $this;
	}

	public function getImageAndVideoCount()
	{
		return (int)$this->image->count() + (int)$this->videos->count();
	}

	public function getContentElementsCols(): int
	{
		return $this->contentElementsCols;
	}

	public function setContentElementsCols(int $contentElementsCols)
	{
		$this->contentElementsCols = $contentElementsCols;
	}

	/**
	 * Get content elements
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage
	 */
	public function getContentElements(): ?\TYPO3\CMS\Extbase\Persistence\ObjectStorage
	{
		return $this->contentElements;
	}

	/**
	 * Set content element list
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage $contentElements content elements
	 */
	public function setContentElements($contentElements): void
	{
		$this->contentElements = $contentElements;
	}

	/**
	 * Adds a content element to the record
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\TtContent $contentElement
	 */
	public function addContentElement(TtContent $contentElement): void
	{
		if ($this->getContentElements() === null) {
			$this->contentElements = new ObjectStorage();
		}
		$this->contentElements->attach($contentElement);
	}

	/**
	 * Get id list of content elements
	 *
	 * @return string
	 */
	public function getContentElementIdList(): string
	{
		return $this->getIdOfContentElements();
	}

	/**
	 * Get translated id list of content elements
	 *
	 * @return string
	 */
	public function getTranslatedContentElementIdList(): string
	{
		return $this->getIdOfContentElements(false);
	}

	/**
	 * Collect id list
	 *
	 * @param bool $original
	 * @return string
	 */
	protected function getIdOfContentElements($original = true): string
	{
		$idList = [];
		$contentElements = $this->getContentElements();
		if ($contentElements) {
			foreach ($this->getContentElements() as $contentElement) {
				if ($contentElement->getColPos() >= 0) {
					$idList[] = $original ? $contentElement->getUid() : $contentElement->_getProperty('_localizedUid');
				}
			}
		}
		return implode(',', $idList);
	}

	public function getPropertiesSortedByCategories(): array
	{
		$propertiesSortedByCategories = [];
		
		foreach($this->getCategory() as $category) {
			foreach($category->getProperties() as $property) {
				foreach($this->getProperties() as $propertyValue) {
					if($propertyValue->getValue() !== '' && $property->getUid() == $propertyValue->getProperty()->getUid()) {
						$propertiesSortedByCategories[] = $propertyValue;
					}
				}
			}
		}

		return $propertiesSortedByCategories;
	}

	public function getPropertiesSortedByCategoriesForDetailview(): array
	{
		$propertiesSortedByCategories = [];
		
		foreach($this->getCategory() as $category) {
			foreach($category->getProperties() as $property) {
				foreach($this->getProperties() as $propertyValue) {
					if($propertyValue->getValue() !== '' && $property->getUid() == $propertyValue->getProperty()->getUid()
					   && $propertyValue->getProperty()->getShowInDetailpage()) {
						$propertiesSortedByCategories[] = $propertyValue;
					}
				}
			}
		}

		return $propertiesSortedByCategories;
	}

	public function getPropertiesDescriptionTop(): string
	{
		return $this->propertiesDescriptionTop;
	}

	public function setPropertiesDescriptionTop($propertiesDescriptionTop): void
	{
		$this->propertiesDescriptionTop = $propertiesDescriptionTop;
	}

	public function getPropertiesDescriptionBottom(): string
	{
		return $this->propertiesDescriptionBottom;
	}

	public function setPropertiesDescriptionBottom(string $propertiesDescriptionBottom): void
	{
		$this->propertiesDescriptionBottom = $propertiesDescriptionBottom;
	}

	public function getContainedAccessoriesDescriptionTop(): string
	{
		return $this->containedAccessoriesDescriptionTop;
	}

	/**
	 * Set the value of containedAccessoriesDescriptionTop
	 *
	 * @return  self
	 */ 
	public function setContainedAccessoriesDescriptionTop(string $containedAccessoriesDescriptionTop): void
	{
		$this->containedAccessoriesDescriptionTop = $containedAccessoriesDescriptionTop;
	}

	public function getContainedAccessoriesDescriptionBottom(): string
	{
		return $this->containedAccessoriesDescriptionBottom;
	}

	public function setContainedAccessoriesDescriptionBottom(string $containedAccessoriesDescriptionBottom): void
	{
		$this->containedAccessoriesDescriptionBottom = $containedAccessoriesDescriptionBottom;
	}

	public function getAdditionalAccessoriesDescriptionTop(): string
	{
		return $this->additionalAccessoriesDescriptionTop;
	}

	public function setAdditionalAccessoriesDescriptionTop(string $additionalAccessoriesDescriptionTop): void
	{
		$this->additionalAccessoriesDescriptionTop = $additionalAccessoriesDescriptionTop;
	}

	public function getAdditionalAccessoriesDescriptionBottom(): string
	{
		return $this->additionalAccessoriesDescriptionBottom;
	}

	public function setAdditionalAccessoriesDescriptionBottom(string $additionalAccessoriesDescriptionBottom): void
	{
		$this->additionalAccessoriesDescriptionBottom = $additionalAccessoriesDescriptionBottom;
	}
	
	public function getContentDescriptionTop(): string
	{
		return $this->contentDescriptionTop;
	}

	public function setContentDescriptionTop(string $contentDescriptionTop): void
	{
		$this->contentDescriptionTop = $contentDescriptionTop;
	}

	public function getContentDescriptionBottom(): string
	{
		return $this->contentDescriptionBottom;
	}

	public function setContentDescriptionBottom(string $contentDescriptionBottom): void
	{
		$this->contentDescriptionBottom = $contentDescriptionBottom;
	}
}
